﻿//************************************************************************************************
// Copyright © 2010 Steven M. Cohn. All Rights Reserved.
//
//************************************************************************************************

namespace iTunerTests
{
	using System;
	using Microsoft.VisualStudio.TestTools.UnitTesting;
	using iTunesLib;
	using iTuner.iTunes;


	/// <summary>
	/// </summary>

	[TestClass]
	public class LyricsTests : TestBase
	{
		private class MockSong : ISong
		{
			private string lyrics;

			public MockSong (string artist, string title)
			{
				this.Artist = artist;
				this.Title = title;
				this.lyrics = String.Empty;
			}

			public string Artist { get; set; }
			public string Title { get; set; }
			public string Lyrics { get { return lyrics; } set { lyrics = value; } }
			public void CacheLyrics (string lyrics) { this.lyrics = lyrics; }
		}


		[TestMethod]
		public void TestProviders ()
		{
			MockSong song = new MockSong("America", "Tin Man");
			//MockSong song = new MockSong("Aaron Neville", "Tell It Like It Is");

			ILyricsProvider provider;
			string lyrics;

			//provider = new Lyrics007Provider();
			//lyrics = provider.RetrieveLyrics(song);
			//Assert.IsFalse(String.IsNullOrEmpty(lyrics));

			//provider = new MP3LyricsProvider();
			//lyrics = provider.RetrieveLyrics(song);
			//Assert.IsFalse(String.IsNullOrEmpty(lyrics));

			provider = new AzLyricsProvider();
			lyrics = provider.RetrieveLyrics(song);
			Assert.IsFalse(String.IsNullOrEmpty(lyrics));

			Console.WriteLine("done");
		}


		[TestMethod]
		public void GetLyrics ()
		{
			MockSong song = new MockSong("Cut Paste", "Time Stands Still");

			//engine.RetrieveLyrics(song);

			// TODO: use ManualResetEvent to wait for this to complete...
		}


		private void DoLyricsUpdated (ITrack track)
		{
			throw new NotImplementedException();
		}


		private void DoProgressReport (ISong song, int stage)
		{
			throw new NotImplementedException();
		}
	}
}
